Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 4292)
@@ -88,5 +88,5 @@
       !!              vertical scale factors.
       !!
-      !! ** Method  : - reference 1D vertical coordinate (gdep._0, e3._0)
+      !! ** Method  : - reference 1D vertical coordinate (gdep._1d, e3._1d)
       !!              - read/set ocean depth and ocean levels (bathy, mbathy)
       !!              - vertical coordinate (gdep., e3.) depending on the 
@@ -153,17 +153,17 @@
       IF( nprint == 1 .AND. lwp )   THEN
          WRITE(numout,*) ' MIN val mbathy ', MINVAL( mbathy(:,:) ), ' MAX ', MAXVAL( mbathy(:,:) )
-         WRITE(numout,*) ' MIN val depth t ', MINVAL( fsdept(:,:,:) ),   &
-            &                   ' w ',   MINVAL( fsdepw(:,:,:) ), '3w ', MINVAL( fsde3w(:,:,:) )
-         WRITE(numout,*) ' MIN val e3    t ', MINVAL( fse3t(:,:,:) ), ' f ', MINVAL( fse3f(:,:,:) ),  &
-            &                   ' u ',   MINVAL( fse3u(:,:,:) ), ' u ', MINVAL( fse3v(:,:,:) ),  &
-            &                   ' uw',   MINVAL( fse3uw(:,:,:)), ' vw', MINVAL( fse3vw(:,:,:)),   &
-            &                   ' w ',   MINVAL( fse3w(:,:,:) )
-
-         WRITE(numout,*) ' MAX val depth t ', MAXVAL( fsdept(:,:,:) ),   &
-            &                   ' w ',   MAXVAL( fsdepw(:,:,:) ), '3w ', MAXVAL( fsde3w(:,:,:) )
-         WRITE(numout,*) ' MAX val e3    t ', MAXVAL( fse3t(:,:,:) ), ' f ', MAXVAL( fse3f(:,:,:) ),  &
-            &                   ' u ',   MAXVAL( fse3u(:,:,:) ), ' u ', MAXVAL( fse3v(:,:,:) ),  &
-            &                   ' uw',   MAXVAL( fse3uw(:,:,:)), ' vw', MAXVAL( fse3vw(:,:,:)),   &
-            &                   ' w ',   MAXVAL( fse3w(:,:,:) )
+         WRITE(numout,*) ' MIN val depth t ', MINVAL( gdept_0(:,:,:) ),   &
+            &                   ' w ',   MINVAL( gdepw_0(:,:,:) ), '3w ', MINVAL( gdep3w_0(:,:,:) )
+         WRITE(numout,*) ' MIN val e3    t ', MINVAL( e3t_0(:,:,:) ), ' f ', MINVAL( e3f_0(:,:,:) ),  &
+            &                   ' u ',   MINVAL( e3u_0(:,:,:) ), ' u ', MINVAL( e3v_0(:,:,:) ),  &
+            &                   ' uw',   MINVAL( e3uw_0(:,:,:)), ' vw', MINVAL( e3vw_0(:,:,:)),   &
+            &                   ' w ',   MINVAL( e3w_0(:,:,:) )
+
+         WRITE(numout,*) ' MAX val depth t ', MAXVAL( gdept_0(:,:,:) ),   &
+            &                   ' w ',   MAXVAL( gdepw_0(:,:,:) ), '3w ', MAXVAL( gdep3w_0(:,:,:) )
+         WRITE(numout,*) ' MAX val e3    t ', MAXVAL( e3t_0(:,:,:) ), ' f ', MAXVAL( e3f_0(:,:,:) ),  &
+            &                   ' u ',   MAXVAL( e3u_0(:,:,:) ), ' u ', MAXVAL( e3v_0(:,:,:) ),  &
+            &                   ' uw',   MAXVAL( e3uw_0(:,:,:)), ' vw', MAXVAL( e3vw_0(:,:,:)),   &
+            &                   ' w ',   MAXVAL( e3w_0(:,:,:) )
       ENDIF
       !
@@ -176,5 +176,5 @@
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE zgr_z  ***
-      !!                    
+      !!                   
       !! ** Purpose :   set the depth of model levels and the resulting 
       !!      vertical scale factors.
@@ -184,11 +184,11 @@
       !!      function the derivative of which gives the scale factors.
       !!        both depth and scale factors only depend on k (1d arrays).
-      !!              w-level: gdepw_0  = fsdep(k)
-      !!                       e3w_0(k) = dk(fsdep)(k)     = fse3(k)
-      !!              t-level: gdept_0  = fsdep(k+0.5)
-      !!                       e3t_0(k) = dk(fsdep)(k+0.5) = fse3(k+0.5)
-      !!
-      !! ** Action  : - gdept_0, gdepw_0 : depth of T- and W-point (m)
-      !!              - e3t_0  , e3w_0   : scale factors at T- and W-levels (m)
+      !!              w-level: gdepw_1d  = gdep(k)
+      !!                       e3w_1d(k) = dk(gdep)(k)     = e3(k)
+      !!              t-level: gdept_1d  = gdep(k+0.5)
+      !!                       e3t_1d(k) = dk(gdep)(k+0.5) = e3(k+0.5)
+      !!
+      !! ** Action  : - gdept_1d, gdepw_1d : depth of T- and W-point (m)
+      !!              - e3t_1d  , e3w_1d   : scale factors at T- and W-levels (m)
       !!
       !! Reference : Marti, Madec & Delecluse, 1992, JGR, 97, No8, 12,763-12,766.
@@ -262,8 +262,8 @@
             zw = FLOAT( jk )
             zt = FLOAT( jk ) + 0.5_wp
-            gdepw_0(jk) = ( zw - 1 ) * za1
-            gdept_0(jk) = ( zt - 1 ) * za1
-            e3w_0  (jk) =  za1
-            e3t_0  (jk) =  za1
+            gdepw_1d(jk) = ( zw - 1 ) * za1
+            gdept_1d(jk) = ( zt - 1 ) * za1
+            e3w_1d  (jk) =  za1
+            e3t_1d  (jk) =  za1
          END DO
       ELSE                                ! Madec & Imbard 1996 function
@@ -272,8 +272,8 @@
                zw = REAL( jk , wp )
                zt = REAL( jk , wp ) + 0.5_wp
-               gdepw_0(jk) = ( zsur + za0 * zw + za1 * zacr * LOG ( COSH( (zw-zkth) / zacr ) )  )
-               gdept_0(jk) = ( zsur + za0 * zt + za1 * zacr * LOG ( COSH( (zt-zkth) / zacr ) )  )
-               e3w_0  (jk) =          za0      + za1        * TANH(       (zw-zkth) / zacr   )
-               e3t_0  (jk) =          za0      + za1        * TANH(       (zt-zkth) / zacr   )
+               gdepw_1d(jk) = ( zsur + za0 * zw + za1 * zacr * LOG ( COSH( (zw-zkth) / zacr ) )  )
+               gdept_1d(jk) = ( zsur + za0 * zt + za1 * zacr * LOG ( COSH( (zt-zkth) / zacr ) )  )
+               e3w_1d  (jk) =          za0      + za1        * TANH(       (zw-zkth) / zacr   )
+               e3t_1d  (jk) =          za0      + za1        * TANH(       (zt-zkth) / zacr   )
             END DO
          ELSE
@@ -282,21 +282,21 @@
                zt = FLOAT( jk ) + 0.5_wp
                ! Double tanh function
-               gdepw_0(jk) = ( zsur + za0 * zw + za1 * zacr * LOG ( COSH( (zw-zkth ) / zacr  ) )    &
-                  &                            + za2 * zacr2* LOG ( COSH( (zw-zkth2) / zacr2 ) )  )
-               gdept_0(jk) = ( zsur + za0 * zt + za1 * zacr * LOG ( COSH( (zt-zkth ) / zacr  ) )    &
-                  &                            + za2 * zacr2* LOG ( COSH( (zt-zkth2) / zacr2 ) )  )
-               e3w_0  (jk) =          za0      + za1        * TANH(       (zw-zkth ) / zacr  )    &
-                  &                            + za2        * TANH(       (zw-zkth2) / zacr2 )
-               e3t_0  (jk) =          za0      + za1        * TANH(       (zt-zkth ) / zacr  )    &
-                  &                            + za2        * TANH(       (zt-zkth2) / zacr2 )
+               gdepw_1d(jk) = ( zsur + za0 * zw + za1 * zacr * LOG ( COSH( (zw-zkth ) / zacr  ) )    &
+                  &                             + za2 * zacr2* LOG ( COSH( (zw-zkth2) / zacr2 ) )  )
+               gdept_1d(jk) = ( zsur + za0 * zt + za1 * zacr * LOG ( COSH( (zt-zkth ) / zacr  ) )    &
+                  &                             + za2 * zacr2* LOG ( COSH( (zt-zkth2) / zacr2 ) )  )
+               e3w_1d  (jk) =          za0      + za1        * TANH(       (zw-zkth ) / zacr  )      &
+                  &                             + za2        * TANH(       (zw-zkth2) / zacr2 )
+               e3t_1d  (jk) =          za0      + za1        * TANH(       (zt-zkth ) / zacr  )      &
+                  &                             + za2        * TANH(       (zt-zkth2) / zacr2 )
             END DO
          ENDIF
-         gdepw_0(1) = 0._wp                    ! force first w-level to be exactly at zero
+         gdepw_1d(1) = 0._wp                    ! force first w-level to be exactly at zero
       ENDIF
 
 !!gm BUG in s-coordinate this does not work!
       ! deepest/shallowest W level Above/Below ~10m
-      zrefdep = 10._wp - 0.1_wp * MINVAL( e3w_0 )                    ! ref. depth with tolerance (10% of minimum layer thickness)
-      nlb10 = MINLOC( gdepw_0, mask = gdepw_0 > zrefdep, dim = 1 )   ! shallowest W level Below ~10m
+      zrefdep = 10._wp - 0.1_wp * MINVAL( e3w_1d )                   ! ref. depth with tolerance (10% of minimum layer thickness)
+      nlb10 = MINLOC( gdepw_1d, mask = gdepw_1d > zrefdep, dim = 1 ) ! shallowest W level Below ~10m
       nla10 = nlb10 - 1                                              ! deepest    W level Above ~10m
 !!gm end bug
@@ -305,10 +305,10 @@
          WRITE(numout,*)
          WRITE(numout,*) '              Reference z-coordinate depth and scale factors:'
-         WRITE(numout, "(9x,' level   gdept    gdepw     e3t      e3w  ')" )
-         WRITE(numout, "(10x, i4, 4f9.2)" ) ( jk, gdept_0(jk), gdepw_0(jk), e3t_0(jk), e3w_0(jk), jk = 1, jpk )
+         WRITE(numout, "(9x,' level  gdept_1d  gdepw_1d  e3t_1d   e3w_1d  ')" )
+         WRITE(numout, "(10x, i4, 4f9.2)" ) ( jk, gdept_1d(jk), gdepw_1d(jk), e3t_1d(jk), e3w_1d(jk), jk = 1, jpk )
       ENDIF
       DO jk = 1, jpk                      ! control positivity
-         IF( e3w_0  (jk) <= 0._wp .OR. e3t_0  (jk) <= 0._wp )   CALL ctl_stop( 'dom:zgr_z: e3w or e3t =< 0 '    )
-         IF( gdepw_0(jk) <  0._wp .OR. gdept_0(jk) <  0._wp )   CALL ctl_stop( 'dom:zgr_z: gdepw or gdept < 0 ' )
+         IF( e3w_1d  (jk) <= 0._wp .OR. e3t_1d  (jk) <= 0._wp )   CALL ctl_stop( 'dom:zgr_z: e3w_1d or e3t_1d =< 0 '    )
+         IF( gdepw_1d(jk) <  0._wp .OR. gdept_1d(jk) <  0._wp )   CALL ctl_stop( 'dom:zgr_z: gdepw_1d or gdept_1d < 0 ' )
       END DO
       !
@@ -382,5 +382,5 @@
                   idta(:,:) = jpkm1
                   DO jk = 1, jpkm1
-                     WHERE( gdept_0(jk) < zdta(:,:) .AND. zdta(:,:) <= gdept_0(jk+1) )   idta(:,:) = jk
+                     WHERE( gdept_1d(jk) < zdta(:,:) .AND. zdta(:,:) <= gdept_1d(jk+1) )   idta(:,:) = jk
                   END DO
                ENDIF
@@ -388,6 +388,6 @@
                IF(lwp) WRITE(numout,*) '         Depth = depthw(jpkm1)'
                idta(:,:) = jpkm1                            ! before last level
-               zdta(:,:) = gdepw_0(jpk)                     ! last w-point depth
-               h_oce     = gdepw_0(jpk)
+               zdta(:,:) = gdepw_1d(jpk)                     ! last w-point depth
+               h_oce     = gdepw_1d(jpk)
             ENDIF
          ELSE                                         ! bump centered in the basin
@@ -398,5 +398,5 @@
             r_bump  = 50000._wp                            ! bump radius (meters)       
             h_bump  =  2700._wp                            ! bump height (meters)
-            h_oce   = gdepw_0(jpk)                         ! background ocean depth (meters)
+            h_oce   = gdepw_1d(jpk)                        ! background ocean depth (meters)
             IF(lwp) WRITE(numout,*) '            bump characteristics: '
             IF(lwp) WRITE(numout,*) '               bump center (i,j)   = ', ii_bump, ii_bump
@@ -418,5 +418,5 @@
                idta(:,:) = jpkm1
                DO jk = 1, jpkm1
-                  WHERE( gdept_0(jk) < zdta(:,:) .AND. zdta(:,:) <= gdept_0(jk+1) )   idta(:,:) = jk
+                  WHERE( gdept_1d(jk) < zdta(:,:) .AND. zdta(:,:) <= gdept_1d(jk+1) )   idta(:,:) = jk
                END DO
             ENDIF
@@ -460,7 +460,7 @@
             CALL iom_close( inum )
             mbathy(:,:) = INT( bathy(:,:) )
-            !
+            !                                                ! =====================
             IF( cp_cfg == "orca" .AND. jp_cfg == 2 ) THEN    ! ORCA R2 configuration
-               !
+               !                                             ! =====================
                IF( nn_cla == 0 ) THEN
                   ii0 = 140   ;   ii1 = 140                  ! Gibraltar Strait open 
@@ -531,7 +531,7 @@
       IF ( .not. ln_sco ) THEN                                !==  set a minimum depth  ==!
          IF( rn_hmin < 0._wp ) THEN    ;   ik = - INT( rn_hmin )                                      ! from a nb of level
-         ELSE                          ;   ik = MINLOC( gdepw_0, mask = gdepw_0 > rn_hmin, dim = 1 )  ! from a depth
+         ELSE                          ;   ik = MINLOC( gdepw_1d, mask = gdepw_1d > rn_hmin, dim = 1 )  ! from a depth
          ENDIF
-         zhmin = gdepw_0(ik+1)                                                         ! minimum depth = ik+1 w-levels 
+         zhmin = gdepw_1d(ik+1)                                                         ! minimum depth = ik+1 w-levels 
          WHERE( bathy(:,:) <= 0._wp )   ;   bathy(:,:) = 0._wp                         ! min=0     over the lands
          ELSE WHERE                     ;   bathy(:,:) = MAX(  zhmin , bathy(:,:)  )   ! min=zhmin over the oceans
@@ -798,14 +798,14 @@
       !
       DO jk = 1, jpk
-            gdept(:,:,jk) = gdept_0(jk)
-            gdepw(:,:,jk) = gdepw_0(jk)
-            gdep3w(:,:,jk) = gdepw_0(jk)
-            e3t (:,:,jk) = e3t_0(jk)
-            e3u (:,:,jk) = e3t_0(jk)
-            e3v (:,:,jk) = e3t_0(jk)
-            e3f (:,:,jk) = e3t_0(jk)
-            e3w (:,:,jk) = e3w_0(jk)
-            e3uw(:,:,jk) = e3w_0(jk)
-            e3vw(:,:,jk) = e3w_0(jk)
+         gdept_0 (:,:,jk) = gdept_1d(jk)
+         gdepw_0 (:,:,jk) = gdepw_1d(jk)
+         gdep3w_0(:,:,jk) = gdepw_1d(jk)
+         e3t_0   (:,:,jk) = e3t_1d  (jk)
+         e3u_0   (:,:,jk) = e3t_1d  (jk)
+         e3v_0   (:,:,jk) = e3t_1d  (jk)
+         e3f_0   (:,:,jk) = e3t_1d  (jk)
+         e3w_0   (:,:,jk) = e3w_1d  (jk)
+         e3uw_0  (:,:,jk) = e3w_1d  (jk)
+         e3vw_0  (:,:,jk) = e3w_1d  (jk)
       END DO
       !
@@ -832,8 +832,8 @@
       !!      with partial steps  on 3d arrays ( i, j, k ).
       !!
-      !!              w-level: gdepw(i,j,k)  = fsdep(k)
-      !!                       e3w(i,j,k) = dk(fsdep)(k)     = fse3(i,j,k)
-      !!              t-level: gdept(i,j,k)  = fsdep(k+0.5)
-      !!                       e3t(i,j,k) = dk(fsdep)(k+0.5) = fse3(i,j,k+0.5)
+      !!              w-level: gdepw_0(i,j,k)  = gdep(k)
+      !!                       e3w_0(i,j,k) = dk(gdep)(k)     = e3(i,j,k)
+      !!              t-level: gdept_0(i,j,k)  = gdep(k+0.5)
+      !!                       e3t_0(i,j,k) = dk(gdep)(k+0.5) = e3(i,j,k+0.5)
       !!
       !!        With the help of the bathymetric file ( bathymetry_depth_ORCA_R2.nc),
@@ -843,5 +843,5 @@
       !!              - bathy = 0 => mbathy = 0
       !!              - 1 < mbathy < jpkm1    
-      !!              - bathy > gdepw(jpk) => mbathy = jpkm1  
+      !!              - bathy > gdepw_0(jpk) => mbathy = jpkm1  
       !!
       !!        Then, for each case, we find the new depth at t- and w- levels
@@ -855,6 +855,6 @@
       !!      schemes.
       !!
-      !!         c a u t i o n : gdept_0, gdepw_0 and e3._0 are positives
-      !!         - - - - - - -   gdept, gdepw and e3. are positives
+      !!         c a u t i o n : gdept_1d, gdepw_1d and e3._1d are positives
+      !!         - - - - - - -   gdept_0, gdepw_0 and e3. are positives
       !!      
       !!  Reference :   Pacanowsky & Gnanadesikan 1997, Mon. Wea. Rev., 126, 3248-3270.
@@ -892,5 +892,5 @@
       ! bathymetry in level (from bathy_meter)
       ! ===================
-      zmax = gdepw_0(jpk) + e3t_0(jpk)          ! maximum depth (i.e. the last ocean level thickness <= 2*e3t_0(jpkm1) )
+      zmax = gdepw_1d(jpk) + e3t_1d(jpk)        ! maximum depth (i.e. the last ocean level thickness <= 2*e3t_1d(jpkm1) )
       bathy(:,:) = MIN( zmax ,  bathy(:,:) )    ! bounded value of bathy (min already set at the end of zgr_bat)
       WHERE( bathy(:,:) == 0._wp )   ;   mbathy(:,:) = 0       ! land  : set mbathy to 0
@@ -900,8 +900,8 @@
       ! Compute mbathy for ocean points (i.e. the number of ocean levels)
       ! find the number of ocean levels such that the last level thickness
-      ! is larger than the minimum of e3zps_min and e3zps_rat * e3t_0 (where
-      ! e3t_0 is the reference level thickness
+      ! is larger than the minimum of e3zps_min and e3zps_rat * e3t_1d (where
+      ! e3t_1d is the reference level thickness
       DO jk = jpkm1, 1, -1
-         zdepth = gdepw_0(jk) + MIN( e3zps_min, e3t_0(jk)*e3zps_rat )
+         zdepth = gdepw_1d(jk) + MIN( e3zps_min, e3t_1d(jk)*e3zps_rat )
          WHERE( 0._wp < bathy(:,:) .AND. bathy(:,:) <= zdepth )   mbathy(:,:) = jk-1
       END DO
@@ -909,8 +909,8 @@
       ! Scale factors and depth at T- and W-points
       DO jk = 1, jpk                        ! intitialization to the reference z-coordinate
-         gdept(:,:,jk) = gdept_0(jk)
-         gdepw(:,:,jk) = gdepw_0(jk)
-         e3t  (:,:,jk) = e3t_0  (jk)
-         e3w  (:,:,jk) = e3w_0  (jk)
+         gdept_0(:,:,jk) = gdept_1d(jk)
+         gdepw_0(:,:,jk) = gdepw_1d(jk)
+         e3t_0  (:,:,jk) = e3t_1d  (jk)
+         e3w_0  (:,:,jk) = e3w_1d  (jk)
       END DO
       ! 
@@ -922,31 +922,31 @@
                IF( ik == jpkm1 ) THEN
                   zdepwp = bathy(ji,jj)
-                  ze3tp  = bathy(ji,jj) - gdepw_0(ik)
-                  ze3wp = 0.5_wp * e3w_0(ik) * ( 1._wp + ( ze3tp/e3t_0(ik) ) )
-                  e3t(ji,jj,ik  ) = ze3tp
-                  e3t(ji,jj,ik+1) = ze3tp
-                  e3w(ji,jj,ik  ) = ze3wp
-                  e3w(ji,jj,ik+1) = ze3tp
-                  gdepw(ji,jj,ik+1) = zdepwp
-                  gdept(ji,jj,ik  ) = gdept_0(ik-1) + ze3wp
-                  gdept(ji,jj,ik+1) = gdept(ji,jj,ik) + ze3tp
+                  ze3tp  = bathy(ji,jj) - gdepw_1d(ik)
+                  ze3wp = 0.5_wp * e3w_1d(ik) * ( 1._wp + ( ze3tp/e3t_1d(ik) ) )
+                  e3t_0(ji,jj,ik  ) = ze3tp
+                  e3t_0(ji,jj,ik+1) = ze3tp
+                  e3w_0(ji,jj,ik  ) = ze3wp
+                  e3w_0(ji,jj,ik+1) = ze3tp
+                  gdepw_0(ji,jj,ik+1) = zdepwp
+                  gdept_0(ji,jj,ik  ) = gdept_1d(ik-1) + ze3wp
+                  gdept_0(ji,jj,ik+1) = gdept_0(ji,jj,ik) + ze3tp
                   !
                ELSE                         ! standard case
-                  IF( bathy(ji,jj) <= gdepw_0(ik+1) ) THEN   ;   gdepw(ji,jj,ik+1) = bathy(ji,jj)
-                  ELSE                                       ;   gdepw(ji,jj,ik+1) = gdepw_0(ik+1)
+                  IF( bathy(ji,jj) <= gdepw_1d(ik+1) ) THEN  ;   gdepw_0(ji,jj,ik+1) = bathy(ji,jj)
+                  ELSE                                       ;   gdepw_0(ji,jj,ik+1) = gdepw_1d(ik+1)
                   ENDIF
-!gm Bug?  check the gdepw_0
+!gm Bug?  check the gdepw_1d
                   !       ... on ik
-                  gdept(ji,jj,ik) = gdepw_0(ik) + ( gdepw  (ji,jj,ik+1) - gdepw_0(ik) )   &
-                     &                          * ((gdept_0(      ik  ) - gdepw_0(ik) )   &
-                     &                          / ( gdepw_0(      ik+1) - gdepw_0(ik) ))
-                  e3t  (ji,jj,ik) = e3t_0  (ik) * ( gdepw  (ji,jj,ik+1) - gdepw_0(ik) )   & 
-                     &                          / ( gdepw_0(      ik+1) - gdepw_0(ik) ) 
-                  e3w  (ji,jj,ik) = 0.5_wp * ( gdepw(ji,jj,ik+1) + gdepw_0(ik+1) - 2._wp * gdepw_0(ik) )   &
-                     &                     * ( e3w_0(ik) / ( gdepw_0(ik+1) - gdepw_0(ik) ) )
+                  gdept_0(ji,jj,ik) = gdepw_1d(ik) + ( gdepw_0   (ji,jj,ik+1) - gdepw_1d(ik) )   &
+                     &                           * ((gdept_1d(      ik  ) - gdepw_1d(ik) )   &
+                     &                           / ( gdepw_1d(      ik+1) - gdepw_1d(ik) ))
+                  e3t_0(ji,jj,ik) = e3t_1d (ik) * ( gdepw_0 (ji,jj,ik+1) - gdepw_1d(ik) )   & 
+                     &                          / ( gdepw_1d(      ik+1) - gdepw_1d(ik) ) 
+                  e3w_0(ji,jj,ik) = 0.5_wp * ( gdepw_0(ji,jj,ik+1) + gdepw_1d(ik+1) - 2._wp * gdepw_1d(ik) )   &
+                     &                     * ( e3w_1d(ik) / ( gdepw_1d(ik+1) - gdepw_1d(ik) ) )
                   !       ... on ik+1
-                  e3w  (ji,jj,ik+1) = e3t  (ji,jj,ik)
-                  e3t  (ji,jj,ik+1) = e3t  (ji,jj,ik)
-                  gdept(ji,jj,ik+1) = gdept(ji,jj,ik) + e3t(ji,jj,ik)
+                  e3w_0  (ji,jj,ik+1) = e3t_0  (ji,jj,ik)
+                  e3t_0  (ji,jj,ik+1) = e3t_0  (ji,jj,ik)
+                  gdept_0(ji,jj,ik+1) = gdept_0(ji,jj,ik) + e3t_0(ji,jj,ik)
                ENDIF
             ENDIF
@@ -959,14 +959,14 @@
             ik = mbathy(ji,jj)
             IF( ik > 0 ) THEN               ! ocean point only
-               e3tp (ji,jj) = e3t(ji,jj,ik  )
-               e3wp (ji,jj) = e3w(ji,jj,ik  )
+               e3tp (ji,jj) = e3t_0(ji,jj,ik)
+               e3wp (ji,jj) = e3w_0(ji,jj,ik)
                ! test
-               zdiff= gdepw(ji,jj,ik+1) - gdept(ji,jj,ik  )
+               zdiff= gdepw_0(ji,jj,ik+1) - gdept_0(ji,jj,ik  )
                IF( zdiff <= 0._wp .AND. lwp ) THEN 
                   it = it + 1
                   WRITE(numout,*) ' it      = ', it, ' ik      = ', ik, ' (i,j) = ', ji, jj
                   WRITE(numout,*) ' bathy = ', bathy(ji,jj)
-                  WRITE(numout,*) ' gdept = ', gdept(ji,jj,ik), ' gdepw = ', gdepw(ji,jj,ik+1), ' zdiff = ', zdiff
-                  WRITE(numout,*) ' e3tp  = ', e3t  (ji,jj,ik), ' e3wp  = ', e3w  (ji,jj,ik  )
+                  WRITE(numout,*) ' gdept_0 = ', gdept_0(ji,jj,ik), ' gdepw_0 = ', gdepw_0(ji,jj,ik+1), ' zdiff = ', zdiff
+                  WRITE(numout,*) ' e3tp    = ', e3t_0  (ji,jj,ik), ' e3wp    = ', e3w_0  (ji,jj,ik  )
                ENDIF
             ENDIF
@@ -976,63 +976,63 @@
       ! Scale factors and depth at U-, V-, UW and VW-points
       DO jk = 1, jpk                        ! initialisation to z-scale factors
-         e3u (:,:,jk) = e3t_0(jk)
-         e3v (:,:,jk) = e3t_0(jk)
-         e3uw(:,:,jk) = e3w_0(jk)
-         e3vw(:,:,jk) = e3w_0(jk)
+         e3u_0 (:,:,jk) = e3t_1d(jk)
+         e3v_0 (:,:,jk) = e3t_1d(jk)
+         e3uw_0(:,:,jk) = e3w_1d(jk)
+         e3vw_0(:,:,jk) = e3w_1d(jk)
       END DO
       DO jk = 1,jpk                         ! Computed as the minimum of neighbooring scale factors
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-               e3u (ji,jj,jk) = MIN( e3t(ji,jj,jk), e3t(ji+1,jj,jk) )
-               e3v (ji,jj,jk) = MIN( e3t(ji,jj,jk), e3t(ji,jj+1,jk) )
-               e3uw(ji,jj,jk) = MIN( e3w(ji,jj,jk), e3w(ji+1,jj,jk) )
-               e3vw(ji,jj,jk) = MIN( e3w(ji,jj,jk), e3w(ji,jj+1,jk) )
-            END DO
-         END DO
-      END DO
-      CALL lbc_lnk( e3u , 'U', 1._wp )   ;   CALL lbc_lnk( e3uw, 'U', 1._wp )   ! lateral boundary conditions
-      CALL lbc_lnk( e3v , 'V', 1._wp )   ;   CALL lbc_lnk( e3vw, 'V', 1._wp )
+               e3u_0 (ji,jj,jk) = MIN( e3t_0(ji,jj,jk), e3t_0(ji+1,jj,jk) )
+               e3v_0 (ji,jj,jk) = MIN( e3t_0(ji,jj,jk), e3t_0(ji,jj+1,jk) )
+               e3uw_0(ji,jj,jk) = MIN( e3w_0(ji,jj,jk), e3w_0(ji+1,jj,jk) )
+               e3vw_0(ji,jj,jk) = MIN( e3w_0(ji,jj,jk), e3w_0(ji,jj+1,jk) )
+            END DO
+         END DO
+      END DO
+      CALL lbc_lnk( e3u_0 , 'U', 1._wp )   ;   CALL lbc_lnk( e3uw_0, 'U', 1._wp )   ! lateral boundary conditions
+      CALL lbc_lnk( e3v_0 , 'V', 1._wp )   ;   CALL lbc_lnk( e3vw_0, 'V', 1._wp )
       !
       DO jk = 1, jpk                        ! set to z-scale factor if zero (i.e. along closed boundaries)
-         WHERE( e3u (:,:,jk) == 0._wp )   e3u (:,:,jk) = e3t_0(jk)
-         WHERE( e3v (:,:,jk) == 0._wp )   e3v (:,:,jk) = e3t_0(jk)
-         WHERE( e3uw(:,:,jk) == 0._wp )   e3uw(:,:,jk) = e3w_0(jk)
-         WHERE( e3vw(:,:,jk) == 0._wp )   e3vw(:,:,jk) = e3w_0(jk)
+         WHERE( e3u_0 (:,:,jk) == 0._wp )   e3u_0 (:,:,jk) = e3t_1d(jk)
+         WHERE( e3v_0 (:,:,jk) == 0._wp )   e3v_0 (:,:,jk) = e3t_1d(jk)
+         WHERE( e3uw_0(:,:,jk) == 0._wp )   e3uw_0(:,:,jk) = e3w_1d(jk)
+         WHERE( e3vw_0(:,:,jk) == 0._wp )   e3vw_0(:,:,jk) = e3w_1d(jk)
       END DO
       
       ! Scale factor at F-point
       DO jk = 1, jpk                        ! initialisation to z-scale factors
-         e3f(:,:,jk) = e3t_0(jk)
+         e3f_0(:,:,jk) = e3t_1d(jk)
       END DO
       DO jk = 1, jpk                        ! Computed as the minimum of neighbooring V-scale factors
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-               e3f(ji,jj,jk) = MIN( e3v(ji,jj,jk), e3v(ji+1,jj,jk) )
-            END DO
-         END DO
-      END DO
-      CALL lbc_lnk( e3f, 'F', 1._wp )       ! Lateral boundary conditions
+               e3f_0(ji,jj,jk) = MIN( e3v_0(ji,jj,jk), e3v_0(ji+1,jj,jk) )
+            END DO
+         END DO
+      END DO
+      CALL lbc_lnk( e3f_0, 'F', 1._wp )       ! Lateral boundary conditions
       !
       DO jk = 1, jpk                        ! set to z-scale factor if zero (i.e. along closed boundaries)
-         WHERE( e3f(:,:,jk) == 0._wp )   e3f(:,:,jk) = e3t_0(jk)
+         WHERE( e3f_0(:,:,jk) == 0._wp )   e3f_0(:,:,jk) = e3t_1d(jk)
       END DO
 !!gm  bug ? :  must be a do loop with mj0,mj1
       ! 
-      e3t(:,mj0(1),:) = e3t(:,mj0(2),:)     ! we duplicate factor scales for jj = 1 and jj = 2
-      e3w(:,mj0(1),:) = e3w(:,mj0(2),:) 
-      e3u(:,mj0(1),:) = e3u(:,mj0(2),:) 
-      e3v(:,mj0(1),:) = e3v(:,mj0(2),:) 
-      e3f(:,mj0(1),:) = e3f(:,mj0(2),:) 
+      e3t_0(:,mj0(1),:) = e3t_0(:,mj0(2),:)     ! we duplicate factor scales for jj = 1 and jj = 2
+      e3w_0(:,mj0(1),:) = e3w_0(:,mj0(2),:) 
+      e3u_0(:,mj0(1),:) = e3u_0(:,mj0(2),:) 
+      e3v_0(:,mj0(1),:) = e3v_0(:,mj0(2),:) 
+      e3f_0(:,mj0(1),:) = e3f_0(:,mj0(2),:) 
 
       ! Control of the sign
-      IF( MINVAL( e3t  (:,:,:) ) <= 0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   e3t   <= 0' )
-      IF( MINVAL( e3w  (:,:,:) ) <= 0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   e3w   <= 0' )
-      IF( MINVAL( gdept(:,:,:) ) <  0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   gdepw <  0' )
-      IF( MINVAL( gdepw(:,:,:) ) <  0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   gdepw <  0' )
+      IF( MINVAL( e3t_0  (:,:,:) ) <= 0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   e3t_0 <= 0' )
+      IF( MINVAL( e3w_0  (:,:,:) ) <= 0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   e3w_0 <= 0' )
+      IF( MINVAL( gdept_0(:,:,:) ) <  0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   gdept_0 <  0' )
+      IF( MINVAL( gdepw_0(:,:,:) ) <  0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   gdepw_0 <  0' )
      
-      ! Compute gdep3w (vertical sum of e3w)
-      gdep3w(:,:,1) = 0.5_wp * e3w(:,:,1)
+      ! Compute gdep3w_0 (vertical sum of e3w)
+      gdep3w_0(:,:,1) = 0.5_wp * e3w_0(:,:,1)
       DO jk = 2, jpk
-         gdep3w(:,:,jk) = gdep3w(:,:,jk-1) + e3w(:,:,jk) 
+         gdep3w_0(:,:,jk) = gdep3w_0(:,:,jk-1) + e3w_0(:,:,jk) 
       END DO
         
@@ -1043,10 +1043,10 @@
             DO ji = 1, jpi
                ik = MAX( mbathy(ji,jj), 1 )
-               zprt(ji,jj,1) = e3t   (ji,jj,ik)
-               zprt(ji,jj,2) = e3w   (ji,jj,ik)
-               zprt(ji,jj,3) = e3u   (ji,jj,ik)
-               zprt(ji,jj,4) = e3v   (ji,jj,ik)
-               zprt(ji,jj,5) = e3f   (ji,jj,ik)
-               zprt(ji,jj,6) = gdep3w(ji,jj,ik)
+               zprt(ji,jj,1) = e3t_0   (ji,jj,ik)
+               zprt(ji,jj,2) = e3w_0   (ji,jj,ik)
+               zprt(ji,jj,3) = e3u_0   (ji,jj,ik)
+               zprt(ji,jj,4) = e3v_0   (ji,jj,ik)
+               zprt(ji,jj,5) = e3f_0   (ji,jj,ik)
+               zprt(ji,jj,6) = gdep3w_0(ji,jj,ik)
             END DO
          END DO
@@ -1387,22 +1387,22 @@
       ENDIF 
 
-      CALL lbc_lnk( e3t , 'T', 1._wp )
-      CALL lbc_lnk( e3u , 'U', 1._wp )
-      CALL lbc_lnk( e3v , 'V', 1._wp )
-      CALL lbc_lnk( e3f , 'F', 1._wp )
-      CALL lbc_lnk( e3w , 'W', 1._wp )
-      CALL lbc_lnk( e3uw, 'U', 1._wp )
-      CALL lbc_lnk( e3vw, 'V', 1._wp )
-
-      fsdepw(:,:,:) = gdepw (:,:,:)
-      fsde3w(:,:,:) = gdep3w(:,:,:)
-      !
-      where (e3t   (:,:,:).eq.0.0)  e3t(:,:,:) = 1._wp
-      where (e3u   (:,:,:).eq.0.0)  e3u(:,:,:) = 1._wp
-      where (e3v   (:,:,:).eq.0.0)  e3v(:,:,:) = 1._wp
-      where (e3f   (:,:,:).eq.0.0)  e3f(:,:,:) = 1._wp
-      where (e3w   (:,:,:).eq.0.0)  e3w(:,:,:) = 1._wp
-      where (e3uw  (:,:,:).eq.0.0)  e3uw(:,:,:) = 1._wp
-      where (e3vw  (:,:,:).eq.0.0)  e3vw(:,:,:) = 1._wp
+      CALL lbc_lnk( e3t_0 , 'T', 1._wp )
+      CALL lbc_lnk( e3u_0 , 'U', 1._wp )
+      CALL lbc_lnk( e3v_0 , 'V', 1._wp )
+      CALL lbc_lnk( e3f_0 , 'F', 1._wp )
+      CALL lbc_lnk( e3w_0 , 'W', 1._wp )
+      CALL lbc_lnk( e3uw_0, 'U', 1._wp )
+      CALL lbc_lnk( e3vw_0, 'V', 1._wp )
+
+      fsdepw(:,:,:) = gdepw_0 (:,:,:)
+      fsde3w(:,:,:) = gdep3w_0(:,:,:)
+      !
+      where (e3t_0   (:,:,:).eq.0.0)  e3t_0(:,:,:) = 1.0
+      where (e3u_0   (:,:,:).eq.0.0)  e3u_0(:,:,:) = 1.0
+      where (e3v_0   (:,:,:).eq.0.0)  e3v_0(:,:,:) = 1.0
+      where (e3f_0   (:,:,:).eq.0.0)  e3f_0(:,:,:) = 1.0
+      where (e3w_0   (:,:,:).eq.0.0)  e3w_0(:,:,:) = 1.0
+      where (e3uw_0  (:,:,:).eq.0.0)  e3uw_0(:,:,:) = 1.0
+      where (e3vw_0  (:,:,:).eq.0.0)  e3vw_0(:,:,:) = 1.0
 
 #if defined key_agrif
@@ -1411,17 +1411,17 @@
          !  
          IF((nbondi == -1).OR.(nbondi == 2)) THEN
-            e3u(1,:,:) = e3u(2,:,:)
+            e3u_0(1,:,:) = e3u_0(2,:,:)
          ENDIF
          !
          IF((nbondi ==  1).OR.(nbondi == 2)) THEN
-            e3u(nlci-1,:,:) = e3u(nlci-2,:,:)
+            e3u_0(nlci-1,:,:) = e3u_0(nlci-2,:,:)
          ENDIF
          !
          IF((nbondj == -1).OR.(nbondj == 2)) THEN
-            e3v(:,1,:) = e3v(:,2,:)
+            e3v_0(:,1,:) = e3v_0(:,2,:)
          ENDIF
          !
          IF((nbondj ==  1).OR.(nbondj == 2)) THEN
-            e3v(:,nlcj-1,:) = e3v(:,nlcj-2,:)
+            e3v_0(:,nlcj-1,:) = e3v_0(:,nlcj-2,:)
          ENDIF
          !
@@ -1429,14 +1429,14 @@
 #endif
 
-      fsdept(:,:,:) = gdept (:,:,:)
-      fsdepw(:,:,:) = gdepw (:,:,:)
-      fsde3w(:,:,:) = gdep3w(:,:,:)
-      fse3t (:,:,:) = e3t   (:,:,:)
-      fse3u (:,:,:) = e3u   (:,:,:)
-      fse3v (:,:,:) = e3v   (:,:,:)
-      fse3f (:,:,:) = e3f   (:,:,:)
-      fse3w (:,:,:) = e3w   (:,:,:)
-      fse3uw(:,:,:) = e3uw  (:,:,:)
-      fse3vw(:,:,:) = e3vw  (:,:,:)
+      fsdept(:,:,:) = gdept_0 (:,:,:)
+      fsdepw(:,:,:) = gdepw_0 (:,:,:)
+      fsde3w(:,:,:) = gdep3w_0(:,:,:)
+      fse3t (:,:,:) = e3t_0   (:,:,:)
+      fse3u (:,:,:) = e3u_0   (:,:,:)
+      fse3v (:,:,:) = e3v_0   (:,:,:)
+      fse3f (:,:,:) = e3f_0   (:,:,:)
+      fse3w (:,:,:) = e3w_0   (:,:,:)
+      fse3uw(:,:,:) = e3uw_0  (:,:,:)
+      fse3vw(:,:,:) = e3vw_0  (:,:,:)
 !!
       ! HYBRID : 
